<?php

$customers = json_decode(file_get_contents("../json/customers.json"), true);
$customers_new = array();
$arraySecrets = array();

foreach ($customers as &$client) {
    if (empty($client['clientSecret'])) {
        $secret = hash("md5",$client['name']);
        $secret = uniqid($secret);

        $validator = new VerifyKeys();
        $invalidToken = true;
        while ($invalidToken) {
            $lastKeys = $validator->genLastKeys($secret);
            if (!empty($lastKeys)) {
                $secret .= $lastKeys;
                $invalidToken = false;
            }
        }
        $client['clientSecret'] = $secret;
    }
    $arraySecrets[$client['clientId']] = $client['clientSecret'];
    $customers_new[] = $client;
}

file_put_contents("../json/customers_new.json", json_encode($customers_new, JSON_PRETTY_PRINT));
var_dump($arraySecrets);

class VerifyKeys
{
    public function genLastKeys($key)
    {
        $keyLength = strlen($key);
        if (!empty($key) && $keyLength >= 3) {
            $code = round(ord($key[1]) * ord($key[(int)round((($keyLength / 4) * 0.6))]) / ord($key[$keyLength - 3]));
            return ((string)$code % 9) . ((string)$code % 4);
        }
        return null;
    }
}